GDAL-VECTOR-EXPLODE-COLLECTIONS(1)

NAME
gdal-vector-explode-collections - Explode geometries of type collection of a vector dataset

Added in version 3.12.

SYNOPSIS

    Usage: gdal vector explode-collections [OPTIONS] <INPUT> <OUTPUT>
    Explode geometries of type collection of a vector dataset.
    Positional arguments:
      -i, --input <INPUT>                                  Input vector datasets [required]
      -o, --output <OUTPUT>                                Output vector dataset [required]
    Common Options:
      -h, --help                                           Display help message and exit
      --json-usage                                         Display usage as JSON document and exit
      --config <KEY>=<VALUE>                               Configuration option [may be repeated]
      -q, --quiet                                          Quiet mode (no progress bar)
    Options:
      -l, --layer, --input-layer <INPUT-LAYER>             Input layer name(s) [may be repeated]
      -f, --of, --format, --output-format <OUTPUT-FORMAT>  Output format ("GDALG" allowed)
      --co, --creation-option <KEY>=<VALUE>                Creation option [may be repeated]
      --lco, --layer-creation-option <KEY>=<VALUE>         Layer creation option [may be repeated]
      --overwrite                                          Whether overwriting existing output is allowed
      --update                                             Whether to open existing dataset in update mode
      --overwrite-layer                                    Whether overwriting existing output is allowed
      --append                                             Whether appending to existing layer is allowed
                                                           Mutually exclusive with --upsert
      --output-layer <OUTPUT-LAYER>                        Output layer name
      --skip-errors                                        Skip errors when writing features
      --active-layer <ACTIVE-LAYER>                        Set active layer (if not specified, all)
      --active-geometry <ACTIVE-GEOMETRY>                  Geometry field name to which to restrict the processing (if not specified, all)
      --geometry-type <GEOMETRY-TYPE>                      Geometry type
      --skip-on-type-mismatch                              Skip feature when change of feature geometry type failed
    Advanced Options:
      --if, --input-format <INPUT-FORMAT>                  Input formats [may be repeated]
      --oo, --open-option <KEY>=<VALUE>                    Open options [may be repeated]
      --output-oo, --output-open-option <KEY>=<VALUE>      Output open options [may be repeated]
      --upsert                                             Upsert features (implies 'append')
                                                           Mutually exclusive with --append

DESCRIPTION

gdal vector explode-collections produces one feature for each geometry in any kind of geometry collection.

For example if a feature contains a geometry MULTIPOINT(1 2,3 4), two corresponding target features will be generated: one with a geometry POINT(1 2) and another one with geometry POINT(3 4). Note that collections are not recursively exploded, i.e. GEOMETRYCOLLECTION(GEOMETRYCOLLECTION(POINT (1 2),POINT(3 4)) will be exploded as GEOMETRYCOLLECTION(POINT (1 2),POINT(3 4)).

It can also be used as a step of gdal vector pipeline.

  Standard options

-f, --of, --format, --output-format <OUTPUT-FORMAT>
    Which output vector format to use. Allowed values may be given by gdal --formats | grep vector | grep rw | sort

--co <NAME>=<VALUE>
    Many formats have one or more optional dataset creation options that can be used to control particulars about the file created. For instance, the GeoPackage driver supports creation options to control the version.

    May be repeated.

    The dataset creation options available vary by format driver, and some simple formats have no creation options at all. A list of options supported for a format can be listed with the --formats command line option but the documentation for the format is the definitive source of information on driver creation options. See Vector drivers format specific documentation for legal creation options for each format.

    Note that dataset creation options are different from layer creation options.

-lco <NAME>=<VALUE>
    Layer creation option (format specific)

--overwrite
    Allow program to overwrite existing target file or dataset. Otherwise, by default, gdal errors out if the target file or dataset already exists.

--active-layer <ACTIVE-LAYER>
    Set the active layer. When it is specified, only the layer specified by its name will be subject to the processing. Other layers will be not modified. If this option is not specified, all layers will be subject to the processing.

--active-geometry <ACTIVE-GEOMETRY>
    Set the active geometry field from its name. When it is specified, only the specified geometry field will be subject to the processing. Other geometry fields will be not modified. If this option is not specified, all geometry fields will be subject to the processing. This option can be combined together with --active-layer.

--geometry-type <GEOMETRY-TYPE>
    Change the geometry type of exploded geometries to be one of GEOMETRY, POINT, LINESTRING, POLYGON, CIRCULARSTRING, COMPOUNDCURVE, CURVEPOLYGON, POLYHEDRALSURFACE or TIN. Z, M or ZM suffixes can be appended to the above values to indicate the dimensionality. The presence of geometries that cannot be coerced to the specified type will cause an error, unless --skip-on-type-mismatch is specified.

--skip-on-type-mismatch
    Do not generate output features when their target geometry type does not match the one specified by --geometry-type.

  Advanced options

--oo <NAME>=<VALUE>
    Dataset open option (format specific).

    May be repeated.

--if <format>
    Format/driver name to be attempted to open the input file(s). It is generally not necessary to specify it, but it can be used to skip automatic driver detection, when it fails to select the appropriate driver. This option can be repeated several times to specify several candidate drivers. Note that it does not force those drivers to open the dataset. In particular, some drivers have requirements on file extensions.

    May be repeated.

GDALG OUTPUT (ON-THE-FLY / STREAMED DATASET)

This program supports serializing the command line as a JSON file using the GDALG output format. The resulting file can then be opened as a vector dataset using the GDALG: GDAL Streamed Algorithm driver, and apply the specified pipeline in a on-the-fly / streamed way.

EXAMPLES

  Example 1: Only retain parts of geometry collections that are of type Point.

    $ gdal vector explode-collections --geometry-type=POINT --skip-on-type-mismatch in.gpkg points.shp --overwrite

AUTHOR
Even Rouault <even.rouault@spatialys.com>

COPYRIGHT
1998-2025